FZU 2092 收集水晶 bfs+记忆化搜索 or 暴力

题目链接:收集水晶

一眼看过去,觉得是普通的bfs,初始位置有两个。仔细想了想...好像如果这样的话..........【不知道怎么说...T_T】

dp[12][12][12][12][210] 中dp[x1][y1][x2][y2][t] =value 表示t时刻人和影子分别到x1,y1 和x2, y2位置的时候得到的最大价值是value。

然后呢,因为每个点的状态一定是由它相邻的状态确定的,所以由dp[0][0][0][0][0] = 0就可以得到所有的状态,中间记录最大值即为ans。

这是暴力遍历所有状态,附代码:

// 暴力大法.
#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

char mp[12][12];
int gem[210][12][12];
int dp[12][12][12][12][210];
int dir[5][2] = {1, 0, -1, 0, 0, 1, 0, -1, 0, 0};
int n, m;

bool check(int a, int b) {
    if (a>=0 && a<n && b>=0 && b<m && mp[a][b] == ‘.‘)
        return true;
    return false;
}

int main() {
    int t;
    cin >> t;
    while(t--) {
        cin >> n >> m;
        for (int i=0; i<n; ++i) {
            for (int j=0; j<m; ++j) {
                cin >> mp[i][j];
            }
        }
        int p;
        int maxt = 0;
        memset(gem, 0, sizeof(gem));
        cin >> p;
        for (int i=0; i<p; ++i) {
            int t, x, y, v;
            cin >> t >> x >> y >> v;
            x--; y--;
            gem[t][x][y] += v;
            maxt = max(maxt, t);
        }

        memset(dp, -1, sizeof(dp));
        dp[0][0][0][0][0] = 0;
        int ans = 0;

        for (int t=1; t<=maxt; ++t) {
            for (int x1=0; x1<n; ++x1) {
                for (int y1=0; y1<m; ++y1) {
                    for (int x2=0; x2<n; ++x2) {
                        for (int y2=0; y2<m; ++y2) {
                            if (dp[x1][y1][x2][y2][t-1] != -1) {
                                for (int k=0; k<25; ++k) {
                                    int x11 = x1 + dir[k/5][0];
                                    int y11 = y1 + dir[k/5][1];
                                    int x22 = x2 + dir[k%5][0];
                                    int y22 = y2 + dir[k%5][1];
                                    if (check(x11, y11) && check(x22, y22)) {
                                        if (x11 == x22 && y11 == y22)
                                        dp[x11][y11][x22][y22][t] = max(dp[x11][y11][x22][y22][t], dp[x1][y1][x2][y2][t-1] + gem[t][x11][y11]);
                                        else dp[x11][y11][x22][y22][t] = max(dp[x11][y11][x22][y22][t], dp[x1][y1][x2][y2][t-1] + gem[t][x11][y11] + gem[t][x22][y22]);
                                        ans = max(ans, dp[x11][y11][x22][y22][t]);
                                        //cout << ans << "====\n";
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        cout << ans << endl;
    }
    return 0;
}

然后,也可以用bfs+记忆化搜索...............................思想是一样的,也是遍历所有的状态,每次遇见一个新的,可以由它到达新的位置的时候,就加入队列。当前状态取当前值和想邻点到达值得max。

附代码:

#include <queue>
#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

char mp[12][12];
int gem[210][12][12];
int dp[12][12][12][12][210];
int ans;
int tmax;
int dir[5][2] = {1, 0, -1, 0, 0, 1, 0, -1, 0, 0};
int n, m;

struct Node {
    int x1, y1, x2, y2, t;
    Node (int x1, int y1, int x2, int y2, int t) {
        this->x1 = x1, this->y1 = y1;
        this->x2 = x2, this->y2 = y2;
        this->t = t;
     }
    Node () {
    }
}node[200];

bool check(Node a) {
    if (a.x1 >= 0 && a.x1 < n && a.y1 >= 0 && a.y1 < m && a.x2 >= 0 && a.x2 < n && a.y2 >= 0 && a.y2 < m && mp[a.x1][a.y1] == ‘.‘ && mp[a.x2][a.y2] == ‘.‘)
        return true;
    return false;
}

void bfs(int x1, int y1, int x2, int y2, int t) {
    queue<Node> que;
    Node now(x1, y1, x2, y2, t);
    que.push(now);
    dp[x1][y1][x2][y2][t] = 0;

    while(!que.empty()) {
        now = que.front();
        que.pop();
        if (now.t > tmax) continue;
        for (int i=0; i<25; ++i) {
            Node nxt;
            nxt.x1 = now.x1 + dir[i/5][0];
            nxt.y1 = now.y1 + dir[i/5][1];
            nxt.x2 = now.x2 + dir[i%5][0];
            nxt.y2 = now.y2 + dir[i%5][1];
            nxt.t = now.t + 1;
            if (check(nxt)) {
                int tot = dp[now.x1][now.y1][now.x2][now.y2][now.t] + gem[nxt.t][nxt.x1][nxt.y1] + gem[nxt.t][nxt.x2][nxt.y2];
                if (nxt.x1 == nxt.x2 && nxt.y1 == nxt.y2) tot -= gem[nxt.t][nxt.x1][nxt.y1];
                if (dp[nxt.x1][nxt.y1][nxt.x2][nxt.y2][nxt.t] < tot) {
                    if (dp[nxt.x1][nxt.y1][nxt.x2][nxt.y2][nxt.t] == -1) {
                        que.push(nxt);
                    }
                    dp[nxt.x1][nxt.y1][nxt.x2][nxt.y2][nxt.t] = tot;
                    ans = max(ans, tot);
                }
            }
        }
    }
}

int main() {
    int T;
    cin >> T;
    while(T--) {
        ans = 0;
        cin >> n >> m;
        memset(dp, -1, sizeof(dp));

        for (int i=0; i<n; ++i) {
            for (int j=0; j<m; ++j) {
                cin >> mp[i][j];
            }
        }
        int p;
        cin >> p;
        tmax = 0;
        memset(gem, 0, sizeof(gem));
        for (int i=0; i<p; ++i) {
            int t, x, y, v;
            cin >> t >> x >> y >> v;
            tmax = max(t, tmax);
            x--; y--;
            gem[t][x][y] += v;
        }
        bfs(0, 0, 0, 0, 0);
        cout << ans << endl;
    }
    return 0;
}

因为没有想到两个状态一起表示,所以整个题都没什么感觉,瞄了一眼就过去了.

时间: 2024-10-12 12:20:26

FZU 2092 收集水晶 bfs+记忆化搜索 or 暴力的相关文章

FZU 2092 收集水晶 BFS记忆化搜索

用了两个pii代码有点长…… 记忆化搜索主要还是用用dp数组去记录并更新状态 1 #include<cstdio> 2 #include<iostream> 3 #include<algorithm> 4 #include<cmath> 5 #include<cstring> 6 #include<string> 7 #include<ctime> 8 #include<map> 9 #include<s

FZU 2092 bfs+记忆化搜索

晚上团队训练赛的题 和普通bfs不同的是 这是同时操纵人与影子两个单位进行的bfs 由于可能发生人和影子同时接触水晶 所以不可以分开操作 当时使用node记录人和影子的位置 然后进行两重for循环来分别改变位置 结果超内存 分析了一下应该是队列超了内存 毕竟如果每个点都存入的话一个点最多可以衍生出25个node 然后t最大为200s 一定会超 之间还发生了一些并不能理解的bug 被逼到最后重构才拿到了一个超内存 名次也不好 急需一个ac来赶上去 简直要烧起来了 侧面反映心理素质还是差一些 当时未

【BZOJ 1415】 1415: [Noi2005]聪聪和可可 (bfs+记忆化搜索+期望)

1415: [Noi2005]聪聪和可可 Time Limit: 10 Sec  Memory Limit: 162 MBSubmit: 1640  Solved: 962 Description Input 数据的第1行为两个整数N和E,以空格分隔,分别表示森林中的景点数和连接相邻景点的路的条数. 第2行包含两个整数C和M,以空格分隔,分别表示初始时聪聪和可可所在的景点的编号. 接下来E行,每行两个整数,第i+2行的两个整数Ai和Bi表示景点Ai和景点Bi之间有一条路. 所有的路都是无向的,即

HDU 1428 漫步校园 (BFS + 记忆化搜索)

漫步校园 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3360    Accepted Submission(s): 1009 Problem Description LL最近沉迷于AC不能自拔,每天寝室.机房两点一线.由于长时间坐在电脑边,缺乏运动.他决定充分利用每次从寝室到机房的时间,在校园里散散步.整个HDU校园呈方形布局,可

csu 最优对称路径(bfs+记忆化搜索)

1106: 最优对称路径 Time Limit: 1 Sec  Memory Limit: 128 MBSubmit: 371  Solved: 77[Submit][Status][Web Board] Description 给 一个n行n列的网格,每个格子里有一个1到9的数字.你需要从左上角走到右下角,其中每一步只能往上.下.左.右四个方向之一走到相邻格子,不能斜着走, 也不能走出网格,但可以重复经过一个格子.为了美观,你经过的路径还必须关于“左下-右上”这条对角线对称.下图是一个6x6网

[Swust OJ 409]--小鼠迷宫问题(BFS+记忆化搜索)

题目链接:http://acm.swust.edu.cn/problem/409/ Time limit(ms): 1000 Memory limit(kb): 65535 Description 小鼠a与小鼠b身处一个m×n的迷宫中,如图所示.每一个方格表示迷宫中的一个房间.这m×n个房间中有一些房间是封闭的,不允许任何人进入.在迷宫中任何位置均可沿上,下,左,右4个方向进入未封闭的房间.小鼠a位于迷宫的(p,q)方格中,它必须找出一条通向小鼠b所在的(r,s)方格的路.请帮助小鼠a找出所有通

[ACM] FZU 2092 收集水晶 (DFS,记忆化搜索)

Problem Description shadow来到一片神奇的土地,这片土地上不时会出现一些有价值的水晶,shadow想要收集一些水晶带回去,但是这项任务太繁杂了,于是shadow让自己的影子脱离自己并成为一个助手来帮助自己收集这些水晶. shadow把这片土地划分成n*m个小方格,某些格子会存在一些shadow和他的影子都无法穿越的障碍,比如巨石.树木.野兽等.shadow预先探测到了水晶出现的时间.位置以及它们的价值,但这些水晶的存在就如昙花一现般短暂,若在出现后1秒内没有收集到,它便将

Dfs/Bfs/记忆化搜索问题 | 问题集合

写在前面 动归和搜索似乎我打得特憋懒. 可能是因为搜索打的太少了??? 然后之前做过的一些题我就不再写了,比如填涂颜色/海战啥的? 然后每一题打两种解法(:Dfs/Bfs 前提是在题目里两种都能A P1596 湖计数 题目描述 Due to recent rains, water has pooled in various places in Farmer John's field, which is represented by a rectangle of N x M (1 <= N <=

HDU 5012 Dice (bfs + 记忆化搜索)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5012 Problem Description There are 2 special dices on the table. On each face of the dice, a distinct number was written. Consider a1.a2,a3,a4,a5,a6 to be numbers written on top face, bottom face, left f